//Clock.cpp

//Includes
#include "Clock.h"
#include <time.h>
#include "LogManager.h"
#include <iostream>
#include <unistd.h>

//Prototype
long int delta(void);

//Globals
 struct timespec curr_ts;
 struct timespec prev_ts;
 long int curr_microsec, prev_microsec;
 long int elapsed_time; // in microseconds

 
Clock::Clock()
{
	clock_gettime(CLOCK_REALTIME, &prev_ts); // start timer
}

long int Clock::delta(void)
{
	clock_gettime(CLOCK_REALTIME, &curr_ts); // stop timer

    // convert to total microseconds
    curr_microsec = curr_ts.tv_sec*1000000 + curr_ts.tv_nsec/1000;
    prev_microsec = prev_ts.tv_sec*1000000 + prev_ts.tv_nsec/1000;
    elapsed_time = curr_microsec - prev_microsec;

	//Start the timer to go again
	clock_gettime(CLOCK_REALTIME, &prev_ts); // start timer
	return elapsed_time;

	
}
