//GameManager.h
//Runs the game loop

#ifndef __GAME_MANAGER_H__
#define __GAME_MANAGER_H__

#include <time.h>

#include "Manager.h"
#include <string>
#include "GameObjectList.h"
#include "GameObject.h"
using namespace std;

#define DRAGONFLY_VERSION 1.0
#define DEFAULT_FRAME_TIME 33

class GameManager : public Manager
{

private:
	GameManager (GameManager const&);
	void operator = (GameManager const&);
	GameManager();
	static GameManager* singletonInstance;

protected:
	bool game_over;
	int globalId;
	

public:
	~GameManager();

	static GameManager* getInstance();
	 
	int startUp();
	int startUp(bool append, bool flush);
	int startUp(bool append, bool flush, time_t seed);

    int shutDown();

	void run();
	void run(int frame_time);

	void setGameOver();
	int makeId();
	
	int event_list_count;
	string event[MAX_EVENTS];
	GameObjectList obj_list[MAX_EVENTS];
	
	
	

};
#endif
