//GameObjectList.cpp

//Includes
#include "Clock.h"
#include <time.h>
#include "LogManager.h"
#include "GameManager.h"
#include "GameObject.h"
#include "Position.h"
#include <iostream>
#include <unistd.h>
#include <string>
#include "GameObjectList.h"
#include "GameObjectListIterator.h"
using namespace std;

int count = 0;
GameObject *list[MAX_GAME_OBJECTS];

GameObjectList::GameObjectList()
{
	count = 0;
}

GameObjectList::~GameObjectList()
{
	
}

//insert game object pointer in list
//return 0 OK, -1 not okay
int GameObjectList::insert(GameObject *p_go)
{
	if(count >= MAX_GAME_OBJECTS)
	{
		return -1;
	}
   
   list[count] = p_go;
   count++;

   return 0;
}


//remove game object pointer from list
//return 0 OK, -1 not okay
int GameObjectList::remove(GameObject *p_go)
{
	for (int i=0; i<count; i++) 
	{
		if (list[i] == p_go) 
		{
			// found so scoot over
			for (int j=i; j<count; j++)
			{
				list[j] = list[j+1];
			}
			count--;
      return 0; // found
    }
  }
  return -1; // not found
}

//clear list counter to 0
void GameObjectList::clear()
{
	count = 0;
}

//Return pointer object of the ID, Null if not found
GameObject * GameObjectList::find(int id)
{
	for(int i = 0; i < count; i++)
	{
		if(list[i]->getId() == id)
		{
			return list[i];
		}
	}
	return NULL;
}

//Return count of number of objects in the list
int GameObjectList::getCount(void)
{
	return count;
}

GameObjectListIterator *GameObjectList::createIterator() const
{
	return new GameObjectListIterator(this);
}
