#ifndef __GAME_OBJECT_LIST_H__
#define __GAME_OBJECT_LIST_H__

#define MAX_GAME_OBJECTS 10000

#include "GameObject.h"
#include "GameObjectListIterator.h"

class GameObjectListIterator;

class GameObjectList
{

protected:
	int count;
	GameObject *list[MAX_GAME_OBJECTS];

public:
	friend class GameObjectListIterator;
	GameObjectListIterator *createIterator() const;

	GameObjectList();
	~GameObjectList();


	//insert game object pointer in list
	//return 0 OK, -1 not okay
	int insert(GameObject *p_go);


	//remove game object pointer from list
	//return 0 OK, -1 not okay
	int remove(GameObject *p_go);

	//clear list counter to 0
	void clear();

	//Return pointer object of the ID, Null if not found
	GameObject *find(int id);

	//Return count of number of objects in the list
	int getCount(void);
};

#endif
