// InputManager.h

#ifndef __INPUT_MANAGER_H__
#define __INPUT_MANAGER_H__

#include "Manager.h"

// the input manager is a singleton instance
class InputManager : public Manager {

 private:
  InputManager (InputManager const&);  // don't allow copy
  void operator=(InputManager const&); // don't allow assignment
  InputManager();		       // private since a singleton
  static InputManager* singletonInstance;
  bool is_started;

 public:
  virtual ~InputManager();
  static InputManager* getInstance();
  virtual bool isValid(string event_name);
  int startUp();
  void shutDown();
  void getInput();
  bool isStarted();
  int registerInterest(GameObject *p_go, string event_name);
  int unregisterInterest(GameObject *p_go, string event_name);
};

#endif //__INPUT_MANAGER_H__

