//LogManager.cpp

#include "Manager.h"
#include "LogManager.h"
#include <stdarg.h>
#include "Clock.h"


FILE * logFile;
LogManager* LogManager::singletonInstance = NULL;
bool appendGlob;
bool flushGlob;


LogManager::LogManager() 
{
	startUp(false, true);
}

LogManager::~LogManager() 
{
    shutDown();
}

int LogManager::startUp(bool append, bool flush)
{
	appendGlob = append;
	flushGlob = flush;
	logFile = fopen(LOGFILE_NAME, "w");
	return 1;
}

int LogManager::shutDown()
{
	fclose(logFile);
	return 1;
}

// return a nicely-formatted time string: HH:MM:SS
// note: needs error checking!
char *LogManager::getTimeString() {
  time_t rawtime;
  struct tm * timeinfo;
  time ( &rawtime );
  timeinfo = localtime ( &rawtime );
  return asctime (timeinfo);
}

int LogManager::writeLog(const char* fmt, ...)
{
	va_list args;
	va_start (args, fmt);
	vfprintf(logFile, fmt, args);
	fprintf(logFile, ": %s", getTimeString());
	if(flushGlob == true)
	{
		fflush(logFile);
	}
	va_end (args);
	return 1;
}

LogManager* LogManager::getInstance()
{
	if (singletonInstance == NULL) 
	{
		singletonInstance = new LogManager();
	}
	return singletonInstance;
}

