//
// LogManager.h
//

#ifndef __LOG_MANAGER_H__
#define __LOG_MANAGER_H__

#include "Manager.h"
#include <iostream>
#include <fstream>
#include <time.h>


#define LOGFILE_NAME "dragonfly.log"


class LogManager : public Manager {

 private:
  LogManager (LogManager const&);    // don't allow copy
  void operator=(LogManager const&); // don't allow assignment
  LogManager();			     // private since a singleton
  static LogManager* singletonInstance;
 
 protected:
  bool do_flush;		     // true if fflush after each write
  char *getTimeString();	     // returns pretty-formatted string

 public:
  
  ~LogManager();

  static LogManager* getInstance();


  int startUp(bool append, bool flush);

  int shutDown();

  int writeLog(const char *fmt, ...);
};

#endif // __LOG_MANAGER_H__

