//Manager.cpp

//Includes
#include "Clock.h"
#include <time.h>
#include "LogManager.h"
#include "GameManager.h"
#include "GameObject.h"
#include "Position.h"
#include <iostream>
#include <unistd.h>
#include <string>
#include "GameObjectList.h"
#include "GameObjectListIterator.h"
#include "Event.h"
#include "EventStep.h"
#include "Manager.h"
#include <string>
#include "WorldManager.h"
using namespace std;
extern string event[MAX_EVENTS];
extern GameObjectList obj_list[MAX_EVENTS];
extern int event_list_count;

Manager::Manager()
{
  
}

Manager::~Manager()
{
    
}

void Manager::onEvent(Event *p_event)
{
	WorldManager *worldManager = WorldManager::getInstance();
    GameObjectList gol = worldManager->getAllObjects();

     GameObjectListIterator goli(&gol);
     goli.first();
	 
	 while(goli.isDone() == false)
     {
		for(int i = 0; i < event_list_count; i++)
		{
		 if((event[i] == p_event->getType()) && obj_list[i].find(goli.currentObj()->getId())!= NULL)
		 {
			 goli.currentObj()->eventHandler(p_event);
		 }
		}
		 goli.next();
     }
}

int Manager::registerInterest(GameObject *p_go, string event_name)
{
		if(isValid(event_name) == true)
		{
			for(int i = 0; i <= event_list_count; i++)
			{
			
				if(event[i] == event_name)
				{
					obj_list[i].insert(p_go);
					return 0;
				}
			}
			if(event_list_count < MAX_EVENTS)
			{
				 event[event_list_count] = event_name;
				 obj_list[event_list_count].insert(p_go);
				 event_list_count = event_list_count + 1;
			}
			
			return 0;
		}
    return -1;
}

int Manager::unregisterInterest(GameObject *p_go, string event_name)
{
    for(int i = 0; i < event_list_count; i++)
	{
		if(event_name == event[i])
		{
			GameObjectListIterator goli(&obj_list[i]);
			goli.first();
	 
			while(goli.isDone() == false)
			{
				if(p_go == goli.currentObj())
				{
					obj_list[i].remove(goli.currentObj());
					LogManager *logManager = LogManager::getInstance();
					logManager->writeLog("Unregistering Manager Event");
					return 0;
				}
				goli.next();
			}
		}
	}
	return -1;
}

bool Manager::isValid(string event_name)
{
    if(event_name == "step")
    {
        return true;
    }
    return false;
}

int Manager::startUp(bool append, bool flush)
{
    return 1;
}

int Manager::shutDown()
{
    return 1;
}

