//ResourceManager.cpp

#include "Manager.h"
#include "ResourceManager.h"
#include "LogManager.h"
#include "Sprite.h"
#include "Frame.h"
#include "Clock.h"
#include <iostream>
#include <fstream>
#include <string>
using namespace std;

FILE * spriteFile;
ResourceManager* ResourceManager::singletonInstance = NULL;
int cons = 1;
int frames_done = 0;

ResourceManager::ResourceManager() 
{
	sprite_count = 0;
}

ResourceManager::~ResourceManager() 
{
    
}

int ResourceManager::startUp()
{
	return 1;
}

int ResourceManager::shutDown()
{
	return 1;
}


ResourceManager* ResourceManager::getInstance()
{
	if (singletonInstance == NULL) 
	{
		singletonInstance = new ResourceManager();
	}
	return singletonInstance;
}

int ResourceManager::loadSprite(string filename, string label)
{
		ifstream myfile(filename.c_str());

		//Get headers
		frames = readLineInt(&myfile, &cons, "frame");
		width = readLineInt(&myfile, &cons, "width");
		height = readLineInt(&myfile, &cons, "height");
		cout << frames << endl;
		cout << width << endl;
		cout << height << endl;
		
		//get body
		Sprite *aSprite; 
		aSprite = new Sprite(frames);

		for(int i = 0; i < frames; i++)
		{
			aSprite->addFrame(readFrame(&myfile, &cons, width, height));
		}
		myfile.close();
		aSprite->setLabel(label);
		sprite[sprite_count] = aSprite;
		sprite_count++;
		LogManager *logManager = LogManager::getInstance();
		logManager->writeLog("Sprite Loaded!");
		cons = 1;
		
	return -1;
}

int ResourceManager::readLineInt(ifstream *p_file, int *p_line_number, const char *tag)
{
	string line;

	if(p_file->good())
	{
		getline(*p_file, line);
		cons++;
		discardCR(line);
	}
	else
	{
		LogManager *logManager = LogManager::getInstance();
		logManager->writeLog("Error, Header File is no good, Line: %d", cons);
		return -1;
	}

	if(line.find(tag) == -1)
	{
		LogManager *logManager = LogManager::getInstance();
		logManager->writeLog("Error, Does not match tag Line: %d", cons);
		return -1;
	}
	else
	{
		return atoi(&line.c_str()[(strlen(line.c_str())-1)]);
	}
	return -1;
}

Frame ResourceManager::readFrame(ifstream *p_file, int *p_line_number, int width, int height)
{
	string line;
	string frame_str;
	if(frames_done == frames)
	{
		frame_str = "";
		frames_done = 0;
	}
	frames_done++;
	int j = 0 ;
	while(j < height)
	{
		if(p_file->good())
		{
			getline(*p_file, line);
			cons++;
			discardCR(line);
		}
		else
		{
			LogManager *logManager = LogManager::getInstance();
			logManager->writeLog("Error, Frame File is no good Line: %d", cons);
			Frame blank;
			return blank;
		}

		if(line.length() > width)
		{
			LogManager *logManager = LogManager::getInstance();
			logManager->writeLog("Error, Width is incorrect Line: %d", cons);
			logManager->writeLog("Length: %d", width);
			logManager->writeLog("Length: %d", line.length());
			Frame blank;
			return blank;
		}
		else
		{
			frame_str.append(line);
			cout << frame_str << endl;
		}
		j++;
	}
	getline(*p_file, line);
	cons++;
	cout << line << endl;

	if(line.find("end") == -1)
	{
		LogManager *logManager = LogManager::getInstance();
		logManager->writeLog("Error, Missing a 'end' Line: %d", cons);
		Frame blank;
		return blank;
	}
	else
	{
		Frame aframe = Frame::Frame(width,height,frame_str);
		return aframe;
	}
	Frame blank;
	return blank;
}

Sprite *ResourceManager::getSprite(string label)
{
	for(int i = 0; i < sprite_count; i++)
	{
		if(label == sprite[i]->getLabel())
		{
			return sprite[i];
		}
	}
	return NULL;
}

void ResourceManager::discardCR(string &str)
{
	if(str[str.size()-1] == '\r')
	{
		str.erase(str.size() -1);
	}
}

