// ResourceManager.h

#ifndef __RESOURCE_MANAGER_H__
#define __RESOURCE_MANAGER_H__

#define MAX_SPRITES 100

#include <string>

#include "Sprite.h"

using namespace std;

// the resource manager is a singleton instance
class ResourceManager {

 private:
  ResourceManager (ResourceManager const&); // don't allow copy
  void operator=(ResourceManager const&);   // don't allow assignment
  ResourceManager();		// private since a singleton
  Sprite *sprite[MAX_SPRITES];	// array of sprites
  int sprite_count;		// count of number of loaded sprites
  int width;
  int height;
  int frames;
  static ResourceManager* singletonInstance;

 public:
  ~ResourceManager();
  static ResourceManager *getInstance();
  int startUp();
  int shutDown();
  int loadSprite(string filename, string label);
  Sprite *getSprite(string label);
  int readLineInt(ifstream *p_file, int *p_line_number, const char *tag);
  Frame readFrame(ifstream *p_file, int *p_line_number, int width, int height);
  void discardCR(string &str);
};

#endif //__RESOURCE_MANAGER_H__
