#include <string>
#include "Frame.h"
#include "Sprite.h"
#include "GraphicsManager.h"
#include "LogManager.h"

int max_frame_count;
int frame_count;
int color;
Frame *frame;
string label;
extern int COLOR_DEFAULT;



Sprite::Sprite()
{
	
}

Sprite::Sprite(int max_frames)
{
	frame_count = 0;
	width = 0;
	height = 0;
	frame = new Frame[max_frames];
	max_frame_count = max_frames;
	color = COLOR_DEFAULT;
}

Sprite::~Sprite()
{
	delete(frame);	
}

int Sprite::getWidth()
{
	return width;
}
void Sprite::setWidth(int new_width)
{
	width = new_width;
}
int Sprite::getHeight()
{
	return height;
}
void Sprite::setHeight(int new_height)
{
	height = new_height;
}
void Sprite::setLabel(string new_label)
{
	label = new_label;
}

string Sprite::getLabel()
{
	return label;
}

int Sprite::getColor()
{
	return color;
}

void Sprite::setColor(int new_color)
{
	color = new_color;
}

Frame Sprite::getFrame(int frame_number)
{
	if(frame_number < 0 || frame_number >= frame_count)
	{
		LogManager *logManager = LogManager::getInstance();
		logManager->writeLog("Invalid Frame Number Given");
		return frame[frame_count - 1];
	}
	else
	{
		return frame[frame_number];
	}
}

int Sprite::addFrame(Frame new_frame)
{
	if(frame_count == max_frame_count)
	{
		LogManager *logManager = LogManager::getInstance();
		logManager->writeLog("Frame Count Full");
		return -1;
	}
	else
	{
		frame[frame_count] = new_frame;
		frame_count++;
	}

	return 0;
}

int Sprite::getFrameCount()
{
	return frame_count;
}
