// Sprite.h


#ifndef __SPRITE_H__
#define __SPRITE_H__

#include <string>
#include "Frame.h"

using namespace std;


class Sprite {

 private:
  int width;
  int height;
  int max_frame_count;
  int frame_count;
  int color;
  Frame *frame;			// array of frames
  string label;
  Sprite();

 public:
  ~Sprite();
  Sprite(int max_frames);	// frame count fixed upon creation
  int getWidth();
  void setWidth(int new_width);
  int getHeight();
  void setHeight(int new_height);
  void setLabel(string new_label);
  string getLabel();
  int getColor();
  void setColor(int new_color);
  Frame getFrame(int frame_number);
  int addFrame(Frame new_frame);
  int getFrameCount();
};

#endif // __SPRITE_H__
