//Tree.cpp

//Includes
#include "Clock.h"
#include <time.h>
#include "GameManager.h"
#include "GameObject.h"
#include "Position.h"
#include <iostream>
#include <unistd.h>
#include <string>
#include "WorldManager.h"
#include "Hero.h"
#include "Event.h"
#include "EventStep.h"
#include "EventKeyboard.h"
#include "EventMouse.h"
#include "LogManager.h"
#include "Manager.h"
#include "GraphicsManager.h"
#include <stdlib.h>
#include "EventOut.h"
#include "EventCollision.h"
#include "InputManager.h"
#include "ResourceManager.h"
#include "Gui.h"
#include <sstream>
#include "Straight.h"
#include "Tree.h"
using namespace std;
extern bool slowDownEnemies;

Tree::Tree() {
  
	//Sprite and interest data
	  is_solid = false;
    GameObject::setSolid(false);
	
	ResourceManager *rm = ResourceManager::getInstance();
	rm->loadSprite("tree-spr.txt", "tree");

	Manager manager = Manager::Manager();
	manager.registerInterest(this, STEP_EVENT);

	Sprite* p = rm->getSprite("tree");
	GameObject::setSprite(p);
	setSpriteSlowdown(0);

	p->setColor(1);

  WorldManager *world_manager = WorldManager::getInstance();
  world_manager->registerInterest(this, STEP_EVENT);
  
  setType("Tree");

 
  x_velocity = -.1;  
  
  altitude = -1;
  
  pos.setX(world_manager->getBoundary().getHorizontal() + random()%150);
  pos.setY(random()%world_manager->getBoundary().getVertical());
}

Tree::~Tree() {
  WorldManager *world_manager = WorldManager::getInstance();
  world_manager->unregisterInterest(this, STEP_EVENT);
}

void Tree::draw() {
   GameObject::draw();
}

// handle event
// return 0 if ignored, else 1
int Tree::eventHandler(Event *e) {

	 WorldManager *world_manager = WorldManager::getInstance();
  if (e->getType() == STEP_EVENT) 
  {
	if(pos.getY() <= 2)
	{
		pos.setY(3);
	}
	if(pos.getY() >= world_manager->getBoundary().getVertical() -2 )
	{
		pos.setY(world_manager->getBoundary().getVertical() - 3);
	}
  }

  if (e->getType() == OUT_EVENT) 
  {
	  if(pos.getX() < 0)
	  {
		out();
	  }
    return 1;
  }

  return 0;
}

bool Tree::isSolid()
{
	return is_solid;
}

void Tree::out() 
{
  WorldManager *world_manager = WorldManager::getInstance();
   pos.setX(world_manager->getBoundary().getHorizontal() + 10);
}
